RECOVER(8)

NAME
recover - browse and recover NetWorker files

SYNOPSIS
recover [-f] [-n] [-q] [-u] [-i {nNyYrR}] [-d destination] [-c client] [-t date] [ -s server] [ dir]
recover [-f] [-n] [-u] [-q] [-i {nNyYrR}] [-I input file] [-d destination] [-c client] [-t date] [ -s server] -a path...
recover [-f] [-n] [-u] [-q] [-i {nNyYrR}] [-d destination] -s server -S ssid[/cloneid] [-S ssid[/cloneid]]... [ path]...
recover [-f] [-n] [-q] [-i {NYR}] -R recover-target -c client [-d destination] [ -t date] [ -s server] [ dir ]

DESCRIPTION

recover browses the saved file index and recovers selected files from the NetWorker system. The file index is created when files are saved with save(8). When in interactive mode (the default), the user is presented with a view of the index similar to a UNIX filesystem, and may move through the index to select and recover files or entire directories. In automatic mode (-a option), the files specified on the command line are recovered immediately without browsing. While in save set recover mode (-S option), the save set(s) specified are retrieved directly without browsing the NetWorker file index. Use of save set recover mode is restricted to root.

When using recover without the -S option, users who are root may recover any file. The remaining permission checking rules described in the paragraph apply to users who are not root. For files that don't have an Access Control List (ACL), the normal Unix mode bits must allow you to read the file in order to recover it. Files with an ACL can only be recovered by their owner or by root.

OPTIONS

-a  Specifies automatic file recovery with no interactive browsing. Path specifies one or more files or directories to be recovered. Symbolic links are not followed, though the link file itself will be recovered. Mount points are also not followed unless the most recent save(8) was performed with the '-x' option.

-S ssid[/cloneid]
    Specifies save set recover mode and can only be used by root. This mode can be used to implement fast batch file recovery without requiring the NetWorker file index entries. ssid specifies the save set id's for the save set(s) to be recovered. When there are multiple clone instances for a save set, the cloneid can also be specified to select the particular clone instance to be recovered from. When no path arguments are specified, the entire save set contents will be recovered. One more or more path's can be specified to limit which directories and files are actually recovered. If path's are supplied, then the beginning of each path name as it exists in the save set must exactly match one of the path's before it will be recovered. Shell like file name matching using meta characters like `*', `?', and `[...]' is not done. You can use a path that ends in with a slash (`/') to force a directory only match (e.g., use a path of /etc/fs/ instead of /etc/fs to prevent files like /etc/fsck from being recovered as well).

-d destination
    Specifies the destination directory to relocate recovered files. Using this option is equivalent to using the relocate command when in interactive mode (see usage). Relative paths are interpreted relative to the current working directory.

-s server
    Selects which NetWorker server to use. This option is required for save set recover mode (-S).

-c client
    Client is the name of the machine that saved the files. When browsing a directory that was saved by another client, the pathnames will reflect the file tree of the client that saved the files. By default save and recover determine the client name from the filesystem table. This option might be necessary if the -L option was used on the save command. This option cannot be used in conjunction with the -S ssid option (save set recover mode).

-t date
    Display/recover files as of the specified date (in nsr_getdate(3) format). Using this option is equivalent to using the changetime command with the given date when in interactive mode (see usage). This option cannot be used in conjunction with the -S ssid option (save set recover mode).

-q  Turns off the verbose output. The recover command normally runs with verbose output.

-f  Forces recovered files to overwrite any existing files whenever a name conflict occurs. This is the same as specifying -iY.

-n  Does not create any directories when recovering.

-i {nNyYrR}
    Specifies the initial default overwrite response to use when recovering existing files. Only one letter may be specified. This option is the same as the uasm -i option when running in recover mode. See the uasm(8) man page for a detailed explanation of this option. For directed recovers (see the -R option), only 'N', 'Y', and 'R' are valid values.

-I input file
    Takes the paths to recover from the command line, and read paths to recover from the named file. The paths must be listed one per line. If no paths are specified on the command line, then only those paths specified in the file will be recovered. To be used in conjunction with -a option.

-R recover-target
    Specifies the name of the remote machine to direct the recovery. This is used in conjunction with the -c option to specify browsing of another client's index. When the -R option is used, either the -f or the -i option must also be specified in order to instruct the recover target what to do when it is recovering existing files. Note that the values 'N', 'Y', and 'R' are the only valid ones to use with the -i option for directed recovers. Note also that the -a option is not supported with the -R option.

-u  Stops when an error occurs during recovery. Normally, recover treats errors as warnings and tries to continue to recover the rest of the files requested. However, when this option is used, recover will stop recovering on the first error it encounters. This option is not valid for directed recovers.

USAGE
When using recover in the interactive mode, an image of the filesystem at a particular time is presented. Using commands similar to the shell, you can change the view and traverse the filesystem. Files may be selected for recovering, and the actual recover command issued.

The following commands manipulate the view of the filesystem and build the list of files to recover. In all of the commands that take a name argument pattern matching characters can be used. The pattern matching characters and regular expression format are the same as for the UNIX shell sh(1).

ls [ options ] [ name ... ]
List information about the given files and directories. When no name arguments are given, ls lists the contents of the current directory. When a name is given and name is a directory, its contents are displayed. If name is a file, then just that file is displayed. The current directory is represented by a `.' (period). The options to this command correspond to those of the UNIX command, ls(1). An additional recover specific -S option can be used to select the save time instead of the last modified time for sorting (with the -t option) and/or printing (with the -l option). Files that have been added to the recover list are preceded by a `+'. Files that have an ACL have a trailing '+' (e.g. -rw-r--r--+) after the mode bits when viewing file details.

lf [ name ... ]
is the same as ls -F. Directories are marked with a trailing `/', symbolic links with a trailing `@', sockets with a trailing `=', FIFO special files with a trailing `|', and executable files with a trailing `*'.

ll [ name ... ]
is the same as ls -lgsF. Generates a long format listing of files and directories. This command can be used to find the value of a symbolic link.

cd [ directory ]
Change the current working directory to [ directory ]. The default directory is the directory recover was executed in. If directory is a simple symbolic link, cd will follow the symbolic link. However, if directory is a path containing symbolic links anywhere but at the end of the path, the cd command will fail; you should cd a component of the path at a time instead.

pwd Print the full pathname of the current working directory.

add [ name ... ]
Add the current directory, or the named file(s) or directory(s) to the recover list. If a directory is specified, it and all of its descendent files are added to the recover list. Symbolic links are not followed, though the link file itself will be recovered. Mount points are also not followed unless the most recent save(8) was performed with the '-x' option.

delete [ name ... ]
Delete the current directory, or the named file(s) or directory(s) from the recover list. If a directory is specified, that directory and all its descendents are deleted from the list. The most expedient way to recover a majority of files from a directory is to add the directory to the recover list, and then delete the unwanted files.

list [ -l ] | [ -c ]
Display the files on the recover list. With no arguments the recover list is displayed as a list of full path names, one per line, followed but a total count of the files to be recovered. The -c argument prints just the total count of files to be recovered. The -l argument prints the files in the same format as the ll command with the -dS options.

volumes
    Prints a list of the volumes needed to recover the current set of files on the recover list.

recover
    Recover all of the files on the recover list from the NetWorker server. Upon completion the recover list is empty.

verbose
    Toggle the status of the ``verbose'' option. When verbose mode is on, recover displays information about each file as it is recovered. When verbose mode is off, recover only prints information when a problem occurs. The default is verbose mode on.

force
    If name conflicts exist, overwrite any existing files with recovered files.

noforce
    Cancel the force option. When in `noforce' mode, a prompt is issued each time a naming conflict arises between a file being recovered and an existing file. At each prompt, six choices are presented: `y', `Y', `n', `N', `r' and `R'. To overwrite the existing file, select `y'. To rename the file to an automatically generated alternative name, select `r'. Selecting `n' causes the recovered file to be discarded. The capital letters invoke the same action for all subsequent conflicts without further prompting. Hence, selecting `Y' will cause all existing conflicting files to be overwritten, `N' will cause all conflicting recovered files to be discarded, and `R' will automatically rename all conflicting recovered files (except when an external ASM has a conflicting file name that already ends in the rename suffix).

relocate [ directory ]
Change the target recover location to directory. If directory is not specified then the user will be prompted for a destination directory. Relative paths are interpreted relative to the current working directory within the recover program. The recovered files will be placed into this directory, which will be created if necessary. When files from multiple directories are being recovered, they will be placed below this directory with a path relative to the first common parent of all the files to be recovered. For example, if /usr/include/sys/errno.h and /usr/include/stdio.h are being recovered, and the relocation directory is set to /tmp, then the first common parent of these two files is include, so the recovered files will be named /tmp/sys/errno.h, and /tmp/stdio.h.

destination
    Print destination location for recovered file.

exit
    Immediately exit from recover.

help
    Display a summary of the available commands.

?   Same as help.

quit
    Immediately exit from recover. Files on the recover list are not recovered.

changetime [ time ]
Display the filesystem as it existed at a different time. If no time is specified the `current' time is displayed, and a prompt is issued for a `new' time. The new time is given in nsr_getdate(3) format. This format is very flexible. It accepts absolute dates, such as March 17, 1997, and relative dates, such as last Tuesday. Absolute dates can be given in two formats: MM/DD[/YY], and Month DD[, YYYY]. Times can also be specified as either absolute or relative, with absolute times in the format: HH[[:MM][:SS]] [am|pm] [time zone]. For example, 12:30 am, 14:21, and 10 pm PST. The current time is used to calculate unspecified parts of a relative date (e.g. 2 days ago means 2 days ago at the current time), and the end of the day is assumed for unspecified times on an absolute date (e.g. July 2 means July 2 at 11:59:59 PM). By default, the present is used as the current time. The resolution of the filesystem image at a time in the past depends on how often save was run and how far back the NetWorker file index information goes.

versions [ name ]
All instances of the current directory, if name is not specified, or the named file or directory, found in the NetWorker file index are listed. For each instance, three lines of data are displayed. The first line is similar to the ll output. The second line lists the instance's save time. The third line specifies which tape(s) this instance may be recovered from. With appropriate use of the changetime command, any one of the entries may be added to the recover list. As with ls, lf, and ll, files that have been added to the recover list are preceded by a `+'.

SEE ALSO
ls(1), nsr_getdate(3), nsr_service(5), nsr(8), nsrd(8), nsrindexd(8), nwrecover(8), save(8)

DIAGNOSTICS
Recover complains about bad option characters by printing a ``usage'' message describing the available options.

Message from server: other clones exist for failed save set
The request failed on a save set that had multiple clones. The server automatically picks a different clone on each attempt. Recover automatically re-submits its recover request to the server, if any files remain to be recovered.

Path name is within machine:export-point
An informative message that lets you know that the given path name is mounted from a network file server and that the recovery will use the index for the named file server. If the machine is not a NetWorker client, then the -c option may be necessary.

Browsing machine's on-line file index
An informative message that explicitly states which NetWorker client's index is being browsed for interactive recovers that resolve to another machine.

Using server as server for client
An informative message that lets you know which NetWorker server was selected for client's index.

Cannot open recover session with server
This message indicates that some problem was encountered connecting to the NetWorker server on the named machine.

error, name is not on client list
This message indicates that the client invoking the recover command is not in the server's client list. See nsr_service(5) for details.

path: Permission denied
The file name cannot be recovered because you are not root, and you don't have read permission for the file.

path: Permission denied (has acl)
The file name cannot be recovered because you are not root, the file has an ACL (Access Control List), and you are not the owner of the file.